/****************************************************************
   17 October 2020, by Ruud Harmsen.
 ***************************************************************/

#ifndef SHOWINTV_H
#define SHOWINTV_H

struct interv_struct
{
   double ratio;
   double cents;
   char   text[24];
};

/****************************************************************
   This function looks up the musical interval specified by `cents',
   and returns a pointer to a struct that describes the nearest
   matching musical interval from a table. See also:
   https://rudhar.com/musica/intonat/index-en.htm etc.

   p_curr may be NULL, in which case it is ignored. It may also
   be a pointer previously obtained from the same function. Then
   it will be used as a starting point for the search, so that
   usually becomes more efficient.
   If p_curr has any other value, the results will be undefined,
   but probably catastrophic and hard to debug.

   pp_prev and pp_next may be NULL. If not NULL, they should point
   to a struct pointer used to to point the previous/next entry
   in the table. The purpose is showing context.
 ***************************************************************/
struct interv_struct *showintv (
   double cents,
   struct interv_struct *p_curr,
   struct interv_struct **pp_prev,
   struct interv_struct **pp_next
   );

#endif

